//---------------------------------------------------------
//RG Basic Tools Collection
//Copyright © 2004 Ronald D. Grindle

//This file is part of the Rslt services.

//Rslt services is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//Rslt services is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with Rslt services.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------

/*
 * Created on Jun 3, 2004
 */
package com.qanavigation.Basics;

import java.util.ArrayList;

//import rgBasics.RsltStatVal;

/**
 * @author RDG
 *
 * Nicked from the C# original IRslt.cs 
 * 
 * <summary>
 * Interface for the Rslt contract.
 * The implementing class needs the members (sample)
 * 
 * protected string m_ResLastMsg;
 * protected ArrayList m_ResInfo;
 * 
 * to implement the interfaces.
 * Use setResStat() to set the Rslt status throughout the code.
 * </summary>
 */
public interface IRslt {
	
	void addRsltAddFailInfo( String p_Class, String p_Fnct, String p_AddInf1, String p_AddInf2 );
	
	void addRsltAddInfo( String p_AddInfo );
	
	void addRsltAddInfo( IRslt p_aRes );

	IRslt getRslt();
	
	String getRsltLastMsg();

	int getRsltStatVal( );
	
	String getRsltStatValLbl( );
	
	boolean checkRslt( IRslt p_Res );
	
	boolean checkRslt( IRslt p_Res, boolean p_EmptyIsOK );

	ArrayList<String> getRsltAddInfo();
	
	boolean isInStat( int p_Stat );
	
	boolean isOK();
	
	boolean isOK( boolean p_EmptyIsOK );

	boolean notOK();
	
	boolean notOK( boolean p_EmptyIsOK );
	
	void resetRslt( ) ;

	void setInError( String p_ErrMsg );

	void setOK();

	void setRsltByExcp( Exception p_Excp );

	void setRsltStat( IRslt p_aRes );

	void setRsltStat( IRslt p_aRes, String p_ErrMsg );

	void setRsltStat( int p_aResStat );
	
	void setRsltStat( int p_aResStat, String p_ErrMsg );

}
