//---------------------------------------------------------
//RG Basic Tools Collection
//Copyright © 2004 Ronald D. Grindle
//
//This file is part of the Rslt services.
//
//Rslt services is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//Rslt services is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Rslt services.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------

/*
 * Created on Jun 21, 2004
 *
 */
package com.qanavigation.Basics;


/**
 * @author RDG
 *
 */
public class RsltString extends Rslt
{

	private String m_theString;

	/**
	 * Status "isEmpty" by default.
	 *
	 */
	public RsltString() {
			
		init();
	}
	
	/**
	 * 
	 * @param p_IsOK
	 */
	public RsltString( boolean p_IsOK ) {

		init();
		
		if( p_IsOK ) {
			
			setOK();
		}
	}

	/**
	 * Sets the Result to OK.
	 * @param p_String
	 */
	public RsltString( String p_String ) {
			
		m_theString = p_String;
		
		setOK();
	}
	
	/**
	 * Sets the Result to OK.
	 * @param p_Str
	 */
	public void appString( String p_Str ) {
		
		if( isOK( true ) ) {
		
			m_theString += p_Str;
			setOK();
		}
	}

	/**
	 * Returns the string value, which is at least "";
	 * @return
	 */
	public String getString()
	{ 

		return m_theString;
	}

	// --------------------------------------------------------------------------
	protected void init() {

		super.init();

		m_theString = "";

		setRsltStat( RsltStatVal.isEmpty );
	}
	
	/**
	 * Evaluates the status. If the Status is not empty
	 * @return true if string value is empty
	 */
	public boolean isEmpty() {

		boolean isEmpty = false;
			
		if( m_ResStat == RsltStatVal.isEmpty ) {
			
			isEmpty = true;
		}
		else {
			
			/*
			if( m_theString.length() < 1 ){
				
				isEmpty = true;
			}*/
		}
		
		return isEmpty;
	}
	
	/**
	 * Sets the string value. A null is converted to "" and the status is set "empty", otherwise "OK".
	 * @param p_String
	 */
	public void	setString( String p_String )
	{ 
		
		if( null == p_String ) {
			
			setRsltStat( RsltStatVal.isEmpty );
			m_theString = "";
		}
		else {

			m_theString = p_String;
			setOK();
		}
	}
	
	/**
	 * 
	 * @param p_String
	 * @param p_ChgStat
	 */
	public void	setString( String p_String, boolean p_ChgStat )
	{ 
		if( p_ChgStat ) {
			
			setString( p_String );
		}
		else {

			if( null == p_String ) {
				
				m_theString = "";
			}
			else {
			
				m_theString = p_String;
			}			
		}
	}
}

