//---------------------------------------------------------
//  RG Basic Tools Collection
//  Copyright © 2004 -2009 Ronald D. Grindle
//
//This file is part of the Rslt services.
//
//Rslt services is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//Rslt services is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Rslt services.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------
package com.qanavigation.Basics;

import javax.xml.transform.ErrorListener;
import javax.xml.transform.SourceLocator;
import javax.xml.transform.TransformerException;

/**
 * 
 * @author rdgm2
 *
 */
public class TransRslt extends Rslt implements ErrorListener {

	public TransRslt()	{
		
		super();
	}
	
	/**
	 * Construct with default status 'OK' (true) or 'inError' (false).
	 *
	 */
	public TransRslt( boolean p_isOK ) {
		
		super( p_isOK );
	}
	
	/**
	 * Constructor for a specific class
	 * @param p_c
	 */
	public TransRslt( Class p_c ) {

		super( p_c );
	}
	
	/**
	 * Copy constructor for an Interface implementer.
	 * @param p_aRes
	 */
	public TransRslt( IRslt p_aRes ) {

		super( p_aRes );
	}

	/**
	 * Copy constructor for a Rslt object.
	 * @param p_aRes
	 */
	public TransRslt( Rslt p_aRes ) {

		super( p_aRes );
	}
	
	public void error(TransformerException texcp)
			throws TransformerException {

		addRsltAddInfo( "Transformer Error" );
		setRsltByExcp( texcp );
	}

	public void fatalError(TransformerException texcp)
			throws TransformerException {

		addRsltAddInfo( "Transformer Fatal Error" );
		setRsltByExcp( texcp );
	}

	public void warning(TransformerException texcp)
			throws TransformerException {

		addRsltAddInfo( "Transformer Warning" );
		setRsltByExcp( texcp );		

	}
	
	public void setRsltByExcp( TransformerException texcp ) {
	
		String val;
		
		Throwable thr = texcp.getException();
		
		if( null != thr) {
		
			setRsltByExcp( thr ); 
		}
		else {
			
			setRsltByExcp( (Exception)texcp ); 
		}
		
		val = texcp.getLocalizedMessage();
		
		if( null != val ) {
			
			addRsltAddInfo( "Localized Message: " );
			addRsltAddInfo( val );			
		}
	
		val = texcp.getLocationAsString();
		
		if( null != val ) {
			
			addRsltAddInfo( "Location: " );
			addRsltAddInfo( val );
		}
		
		SourceLocator loc = texcp.getLocator();
			
		if( null != loc ) {
			
			addRsltAddInfo( "Locator: " );
			addRsltAddInfo( loc.getPublicId() );
		}
	}
}
